SystemOrganization addCategory: #'TP1-LSD-Inc'!

Trait named: #TAcumulaConsumo
	uses: {}
	category: 'TP1-LSD-Inc'!

!TAcumulaConsumo methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 4/12/2013 10:11'!
consumo
self requiredMethods

! !

!TAcumulaConsumo methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 4/12/2013 10:13'!
consumoAcumulado
^ self consumo + self consumoExtra! !

!TAcumulaConsumo methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 4/12/2013 10:12'!
consumoExtra
self requiredMethods! !

Trait named: #TConsumoImagen
	uses: {}
	category: 'TP1-LSD-Inc'!

!TConsumoImagen methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 05:47'!
consumo
	^ self wattsPorHora * self tamanio! !

!TConsumoImagen methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 05:46'!
tamanio
	self requiredMethods! !

!TConsumoImagen methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:43'!
wattsPorHora
	self requiredMethods! !

Trait named: #TConsumoPorPunto
	uses: {}
	category: 'TP1-LSD-Inc'!

!TConsumoPorPunto methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 4/12/2013 10:41'!
consumo
^ self puntosDefinicionCable * self incrementoPorPunto! !

!TConsumoPorPunto methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 4/12/2013 10:39'!
incrementoPorPunto
self requiredMethods
 ! !

!TConsumoPorPunto methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 4/12/2013 10:38'!
puntosDefinicionCable
self requiredMethods! !

Trait named: #TImagenAnalogica
	uses: TConsumoImagen
	category: 'TP1-LSD-Inc'!

TImagenAnalogica classTrait
	uses: TConsumoImagen classTrait!

!TImagenAnalogica methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:53'!
definicionMaxima
	^ 480! !

Trait named: #TImagenDigital
	uses: TConsumoImagen
	category: 'TP1-LSD-Inc'!

!TImagenDigital commentStamp: '<historical>' prior: 0!
A TImagenDigital is un trait que se encarga de obtener la definicion de una tecnologia digital.
!

TImagenDigital classTrait
	uses: TConsumoImagen classTrait!

!TImagenDigital methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:51'!
definicionMaxima
	^ self ppp * ( ( self tamanio squared / 2 ) raisedTo: 0.5 )! !

!TImagenDigital methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:46'!
ppp
	self requiredMethods! !

Trait named: #TPorcentajeConsumo
	uses: {}
	category: 'TP1-LSD-Inc'!

!TPorcentajeConsumo methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 4/12/2013 10:30'!
consumo: pantalla
^ pantalla * (self porcentaje / 100)! !

!TPorcentajeConsumo methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 4/12/2013 10:25'!
porcentaje
self requiredMethods! !

Object subclass: #Entrada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

Entrada subclass: #AudioVideo
	uses: TPorcentajeConsumo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

AudioVideo class
	uses: TPorcentajeConsumo classTrait
	instanceVariableNames: ''!

!AudioVideo methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 4/12/2013 10:36'!
porcentaje
^ 10! !

Entrada subclass: #HDMI
	uses: TPorcentajeConsumo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

HDMI class
	uses: TPorcentajeConsumo classTrait
	instanceVariableNames: ''!

!HDMI methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 4/12/2013 10:36'!
porcentaje
^ 20! !

Entrada subclass: #RF
	uses: TPorcentajeConsumo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

RF class
	uses: TPorcentajeConsumo classTrait
	instanceVariableNames: ''!

!RF methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 4/12/2013 10:36'!
porcentaje
^ 0! !

Entrada subclass: #VGA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

Object subclass: #Pantalla
	uses: TAcumulaConsumo
	instanceVariableNames: 'entrada refresco tecnologia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

Pantalla class
	uses: TAcumulaConsumo classTrait
	instanceVariableNames: ''!

!Pantalla class methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 08:25'!
newMonitorConTecnologia: tecnologiaDeImagen
	| instance |
	instance := Pantalla new.
	instance tecnologia: tecnologiaDeImagen.
	instance refresco: 120.
	^ instance! !

!Pantalla class methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 08:29'!
newSmartTVDeTamanio: tamanio PPP: ppp
	| instance |
	instance := Pantalla new.
	instance tecnologia: TecnologiaDeImagen newTecnologiaLEDDeTamanio: tamanio PPP: ppp.
	instance refresco: 135.
	^ instance! !

!Pantalla class methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 08:24'!
newTVConTecnologia: tecnologiaDeImagen
	| instance |
	instance := Pantalla new.
	instance tecnologia: tecnologiaDeImagen.
	instance refresco: 90.
	^ instance! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 08:30'!
consumo
	self shouldBeImplemented! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 4/12/2013 10:42'!
consumoExtra
^ entrada consumo: self
! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 06:29'!
refresco
	^ refresco! !

!Pantalla methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 06:06'!
tecnologia
	^ tecnologia! !

Object subclass: #TecnologiaDeImagen
	instanceVariableNames: 'tamanio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

TecnologiaDeImagen subclass: #CRT
	uses: TImagenAnalogica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

CRT class
	uses: TImagenAnalogica classTrait
	instanceVariableNames: ''!

!CRT methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:34'!
wattsPorHora
	^ 5! !

TecnologiaDeImagen subclass: #LCD
	uses: TImagenDigital
	instanceVariableNames: 'ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

LCD class
	uses: TImagenDigital classTrait
	instanceVariableNames: ''!

!LCD methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 03:38'!
ppp
	^ ppp! !

!LCD methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 03:38'!
ppp: anObject
	ppp := anObject! !

!LCD methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:36'!
wattsPorHora
	^ 4! !

TecnologiaDeImagen subclass: #LED
	uses: TImagenDigital
	instanceVariableNames: 'ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP1-LSD-Inc'!

!LED commentStamp: '<historical>' prior: 0!
A LED is una representacion de una pantalla con tecnologia LED.

Instance Variables
	ppp:		<Object>

ppp
	- xxxxx
!

LED class
	uses: TImagenDigital classTrait
	instanceVariableNames: ''!

!LED methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 03:38'!
ppp
	^ ppp! !

!LED methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 03:38'!
ppp: anObject
	ppp := anObject! !

!LED methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:36'!
wattsPorHora
	^ 1! !

!TecnologiaDeImagen class methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 06:20'!
newTecnologiaCRTDeTamanio: tamanio
	| instance |
	instance := CRT new.
	instance tamanio: tamanio.
	^ instance
	! !

!TecnologiaDeImagen class methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 06:21'!
newTecnologiaLCDDeTamanio: tamanio PPP: ppp
	| instance |
	instance := LCD new.
	instance tamanio: tamanio.
	instance ppp: ppp.
	^ instance
	! !

!TecnologiaDeImagen class methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 06:22'!
newTecnologiaLEDDeTamanio: tamanio PPP: ppp
	| instance |
	instance := LED new.
	instance tamanio: tamanio.
	instance ppp: ppp.
	^ instance
	! !

!TecnologiaDeImagen methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 05:46'!
tamanio
	^ tamanio! !

!TecnologiaDeImagen methodsFor: 'accessing' stamp: 'MarChU 4/10/2013 05:46'!
tamanio: anObject
	tamanio := anObject! !

!TecnologiaDeImagen methodsFor: 'as yet unclassified' stamp: 'MarChU 4/10/2013 03:30'!
wattsPorHora
	^ self subclassResponsibility! !
